> ## Documentation Index
> Fetch the complete documentation index at: https://docs.getruba.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Record Events

> ### Intent

Runs the record events action.

### When to call it

Call this when your workflow reaches the point where it must record events.

### Access boundary

Authorize the request with a token that carries `events:write`.

### Successful result

A successful request returns `200`. The response schema below defines the body your integration receives.

### Operational notes

Ingest batch of events.

export const RubaSocials = () => {
  if (typeof document === "undefined") {
    return null;
  }
  const inject = () => {
    const footer = document.getElementById("footer");
    if (!footer || document.getElementById("ruba-socials")) {
      return false;
    }
    const isDark = document.querySelector("html.dark") || document.querySelector('html[class*="dark"]');
    const lineColor = isDark ? "#383838" : "#e8e8ed";
    const iconColor = isDark ? "#8e8e93" : "#86868b";
    const markColor = isDark ? "#ffffff" : "#08080c";
    const hoverColor = "#0071e3";
    const div = document.createElement("div");
    div.id = "ruba-socials";
    div.style.cssText = `display:flex;align-items:center;gap:20px;padding-top:20px;margin-top:20px;border-top:1px solid ${lineColor};width:100%`;
    const logo = `<a href="https://getruba.com" style="display:inline-flex;height:24px;align-items:center;gap:8px;text-decoration:none;color:${markColor};line-height:1;"><svg width="24" height="24" viewBox="0 0 120 120" aria-hidden="true" style="display:block;flex:none;"><g transform="translate(2.5 0)"><path d="M19 25h59L65.43 47H19a4 4 0 0 1-4-4V29a4 4 0 0 1 4-4Z" fill="${markColor}"/><path d="M19 73h31.57L38 95H19a4 4 0 0 1-4-4V77a4 4 0 0 1 4-4Z" fill="${markColor}"/><path d="M85 25h25L70 95H45Z" fill="#007AFF"/></g></svg><span style="display:inline-flex;height:24px;align-items:center;font-weight:600;font-size:15px;color:${markColor};letter-spacing:-0.01em;line-height:1;">Ruba</span></a>`;
    const spacer = `<div style="flex:1"></div>`;
    const ig = `<a href="https://instagram.com/getruba" target="_blank" rel="noopener" aria-label="Instagram" style="display:flex;align-items:center;color:${iconColor};transition:color 0.15s ease;" onmouseover="this.style.color='${hoverColor}'" onmouseout="this.style.color='${iconColor}'"><svg width="20" height="20" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="1.8" stroke-linecap="round" stroke-linejoin="round"><rect x="2" y="2" width="20" height="20" rx="5" ry="5"/><path d="M16 11.37A4 4 0 1 1 12.63 8 4 4 0 0 1 16 11.37z"/><line x1="17.5" y1="6.5" x2="17.51" y2="6.5"/></svg></a>`;
    const li = `<a href="https://linkedin.com/company/getruba" target="_blank" rel="noopener" aria-label="LinkedIn" style="display:flex;align-items:center;color:${iconColor};transition:color 0.15s ease;" onmouseover="this.style.color='${hoverColor}'" onmouseout="this.style.color='${iconColor}'"><svg width="20" height="20" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="1.8" stroke-linecap="round" stroke-linejoin="round"><path d="M16 8a6 6 0 0 1 6 6v7h-4v-7a2 2 0 0 0-2-2 2 2 0 0 0-2 2v7h-4v-7a6 6 0 0 1 6-6z"/><rect x="2" y="9" width="4" height="12"/><circle cx="4" cy="4" r="2"/></svg></a>`;
    const x = `<a href="https://x.com/getruba" target="_blank" rel="noopener" aria-label="X" style="display:flex;align-items:center;color:${iconColor};transition:color 0.15s ease;" onmouseover="this.style.color='${hoverColor}'" onmouseout="this.style.color='${iconColor}'"><svg width="18" height="18" viewBox="0 0 24 24" fill="currentColor"><path d="M18.244 2.25h3.308l-7.227 8.26 8.502 11.24H16.17l-5.214-6.817L4.99 21.75H1.68l7.73-8.835L1.254 2.25H8.08l4.713 6.231zm-1.161 17.52h1.833L7.084 4.126H5.117z"/></svg></a>`;
    const github = `<a href="https://github.com/rubadot" target="_blank" rel="noopener" aria-label="GitHub" style="display:flex;align-items:center;color:${iconColor};transition:color 0.15s ease;" onmouseover="this.style.color='${hoverColor}'" onmouseout="this.style.color='${iconColor}'"><svg width="20" height="20" viewBox="0 0 24 24" fill="currentColor"><path d="M12 .7a11.5 11.5 0 0 0-3.64 22.4c.58.1.79-.25.79-.56v-2.24c-3.22.7-3.9-1.37-3.9-1.37-.53-1.34-1.29-1.7-1.29-1.7-1.05-.72.08-.71.08-.71 1.16.08 1.78 1.2 1.78 1.2 1.04 1.77 2.72 1.26 3.38.96.1-.75.4-1.26.74-1.55-2.57-.3-5.27-1.29-5.27-5.69 0-1.26.45-2.29 1.19-3.09-.12-.29-.52-1.47.11-3.05 0 0 .97-.31 3.16 1.18A10.96 10.96 0 0 1 12 6.09c.98 0 1.94.13 2.86.39 2.2-1.49 3.16-1.18 3.16-1.18.63 1.58.23 2.76.11 3.05.74.8 1.19 1.83 1.19 3.09 0 4.42-2.7 5.39-5.28 5.68.42.36.79 1.06.79 2.14v3.28c0 .31.21.67.8.56A11.5 11.5 0 0 0 12 .7Z"/></svg></a>`;
    div.innerHTML = logo + spacer + ig + li + x + github;
    footer.appendChild(div);
    return true;
  };
  if (!document.documentElement.dataset.rubaSocialsObserver) {
    document.documentElement.dataset.rubaSocialsObserver = "true";
    const observer = new MutationObserver(() => {
      if (!document.getElementById("ruba-socials")) {
        inject();
      }
    });
    observer.observe(document.body, {
      childList: true,
      subtree: true
    });
  }
  setTimeout(() => {
    if (!inject()) {
      const interval = setInterval(() => {
        if (inject()) {
          clearInterval(interval);
        }
      }, 500);
      setTimeout(() => clearInterval(interval), 10000);
    }
  }, 300);
  return null;
};

<link rel="stylesheet" href="/style.css" />

<RubaSocials />


## OpenAPI

````yaml post /v1/events/ingest
openapi: 3.1.0
info:
  title: Ruba API
  summary: Ruba HTTP and Webhooks API
  description: '**Details:** Read the docs at https://docs.getruba.com/api-reference.'
  version: 2026-04
servers:
  - url: https://api.getruba.com
    description: '**Details:** Production environment.'
    x-speakeasy-server-id: production
  - url: https://sandbox-api.getruba.com
    description: '**Details:** Sandbox environment.'
    x-speakeasy-server-id: sandbox
security: []
tags:
  - name: public
    description: >-
      **Details:** Endpoints shown and documented in the Ruba API documentation
      and available in our SDKs.
  - name: private
    description: >-
      **Details:** Endpoints that should appear in the schema only in
      development to generate our internal JS SDK.
paths:
  /v1/events/ingest:
    post:
      tags:
        - events
        - public
      summary: Record Events
      description: >-
        ### Intent


        Runs the record events action.


        ### When to call it


        Call this when your workflow reaches the point where it must record
        events.


        ### Access boundary


        Authorize the request with a token that carries `events:write`.


        ### Successful result


        A successful request returns `200`. The response schema below defines
        the body your integration receives.


        ### Operational notes


        Ingest batch of events.
      operationId: events:ingest
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/EventsIngest'
        required: true
      responses:
        '200':
          description: Request completed successfully
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/EventsIngestResponse'
        '422':
          description: Request validation failed
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/HTTPValidationError'
      security:
        - oidc:
            - events:write
        - pat:
            - events:write
        - oat:
            - events:write
components:
  schemas:
    EventsIngest:
      properties:
        events:
          items:
            anyOf:
              - $ref: '#/components/schemas/EventCreateCustomer'
              - $ref: '#/components/schemas/EventCreateExternalCustomer'
          type: array
          title: Events
          description: Collection of events to ingest.
      type: object
      required:
        - events
      title: EventsIngest
    EventsIngestResponse:
      properties:
        inserted:
          type: integer
          title: Inserted
          description: Count of events inserted.
        duplicates:
          type: integer
          title: Duplicates
          description: Count of duplicate events skipped.
          default: 0
      type: object
      required:
        - inserted
      title: EventsIngestResponse
    HTTPValidationError:
      properties:
        detail:
          items:
            $ref: '#/components/schemas/ValidationError'
          type: array
          title: Detail
      type: object
      title: HTTPValidationError
    EventCreateCustomer:
      properties:
        timestamp:
          type: string
          format: date-time
          title: Timestamp
          description: Time at which the event occurred.
        name:
          type: string
          maxLength: 128
          title: Name
          description: Name assigned to the event.
        organization_id:
          anyOf:
            - type: string
              format: uuid4
              description: Identifier of the organization.
              examples:
                - 1dbfc517-0bbf-4301-9ba8-555ca42b9737
              x-ruba-selector-widget:
                displayProperty: name
                resourceName: Organization
                resourceRoot: /v1/organizations
            - type: 'null'
          title: Organization Id
          description: >-
            Identifier of the organization owning the event. **Required unless
            you use an organization token.**.
        external_id:
          anyOf:
            - type: string
            - type: 'null'
          title: External Id
          description: >-
            **External Id:** Your unique identifier for this event. Useful for
            deduplication and parent-child relationships.
        parent_id:
          anyOf:
            - type: string
            - type: 'null'
          title: Parent Id
          description: >-
            Unique identifier for the parent event. Can be either a Ruba event
            ID (UUID) or an external event ID.
        metadata:
          $ref: '#/components/schemas/EventMetadataInput'
          description: >-
            Metadata map for information your integration needs to retain about
            the event. Some keys like `_llm` are structured data that are
            handled specially by Ruba.


            The key must be a string with a maximum length of **40 characters**.

            The value must be either:


            * A string with a maximum length of **500 characters**

            * An integer

            * A floating-point number

            * A boolean


            You can store up to **50 key-value pairs**.
        customer_id:
          type: string
          format: uuid4
          title: Customer Id
          description: >-
            Identifier of the customer in your Ruba organization associated with
            the event.
        member_id:
          anyOf:
            - type: string
              format: uuid4
            - type: 'null'
          title: Member Id
          description: >-
            Identifier of the member within the customer's organization who
            performed the action. Used for member-level attribution in B2B.
      type: object
      required:
        - name
        - customer_id
      title: EventCreateCustomer
    EventCreateExternalCustomer:
      properties:
        timestamp:
          type: string
          format: date-time
          title: Timestamp
          description: Time at which the event occurred.
        name:
          type: string
          maxLength: 128
          title: Name
          description: Name assigned to the event.
        organization_id:
          anyOf:
            - type: string
              format: uuid4
              description: Identifier of the organization.
              examples:
                - 1dbfc517-0bbf-4301-9ba8-555ca42b9737
              x-ruba-selector-widget:
                displayProperty: name
                resourceName: Organization
                resourceRoot: /v1/organizations
            - type: 'null'
          title: Organization Id
          description: >-
            Identifier of the organization owning the event. **Required unless
            you use an organization token.**.
        external_id:
          anyOf:
            - type: string
            - type: 'null'
          title: External Id
          description: >-
            **External Id:** Your unique identifier for this event. Useful for
            deduplication and parent-child relationships.
        parent_id:
          anyOf:
            - type: string
            - type: 'null'
          title: Parent Id
          description: >-
            Unique identifier for the parent event. Can be either a Ruba event
            ID (UUID) or an external event ID.
        metadata:
          $ref: '#/components/schemas/EventMetadataInput'
          description: >-
            Metadata map for information your integration needs to retain about
            the event. Some keys like `_llm` are structured data that are
            handled specially by Ruba.


            The key must be a string with a maximum length of **40 characters**.

            The value must be either:


            * A string with a maximum length of **500 characters**

            * An integer

            * A floating-point number

            * A boolean


            You can store up to **50 key-value pairs**.
        external_customer_id:
          type: string
          title: External Customer Id
          description: Your system identifier for the customer connected to this event.
        external_member_id:
          anyOf:
            - type: string
            - type: 'null'
          title: External Member Id
          description: >-
            Identifier of the member in your system within the customer's
            organization who performed the action. Used for member-level
            attribution in B2B.
      type: object
      required:
        - name
        - external_customer_id
      title: EventCreateExternalCustomer
    ValidationError:
      properties:
        loc:
          items:
            anyOf:
              - type: string
              - type: integer
          type: array
          title: Location
        msg:
          type: string
          title: Message
        type:
          type: string
          title: Error Type
        input:
          title: Input
        ctx:
          type: object
          title: Context
      type: object
      required:
        - loc
        - msg
        - type
      title: ValidationError
    EventMetadataInput:
      properties:
        _cost:
          $ref: '#/components/schemas/CostMetadata-Input'
        _llm:
          $ref: '#/components/schemas/LLMMetadata'
      additionalProperties:
        anyOf:
          - type: string
            maxLength: 500
            minLength: 1
          - type: integer
          - type: number
          - type: boolean
      type: object
      title: EventMetadataInput
    CostMetadata-Input:
      properties:
        amount:
          anyOf:
            - type: number
            - type: string
              pattern: >-
                ^(?!^[-+.]*$)[+-]?0*(?:\d{0,5}|(?=[\d.]{1,18}0*$)\d{0,5}\.\d{0,12}0*$)
          title: Amount
          description: '**Amount:** Amount in cents.'
        currency:
          type: string
          pattern: usd
          title: Currency
          description: '**Currency:** Currency. Currently, only `usd` is supported.'
      type: object
      required:
        - amount
        - currency
      title: CostMetadata
    LLMMetadata:
      properties:
        vendor:
          type: string
          title: Vendor
          description: '**Vendor:** Vendor of the event.'
        model:
          type: string
          title: Model
          description: '**Model:** Model used for the event.'
        prompt:
          anyOf:
            - type: string
            - type: 'null'
          title: Prompt
          description: '**Prompt:** LLM prompt used for the event.'
        response:
          anyOf:
            - type: string
            - type: 'null'
          title: Response
          description: LLM response used for the event.
        input_tokens:
          type: integer
          title: Input Tokens
          description: Count of LLM input tokens used for the event.
        cached_input_tokens:
          type: integer
          title: Cached Input Tokens
          description: Count of LLM cached tokens that were used for the event.
        output_tokens:
          type: integer
          title: Output Tokens
          description: Count of LLM output tokens used for the event.
        total_tokens:
          type: integer
          title: Total Tokens
          description: '**Total Tokens:** Total number of LLM tokens used for the event.'
      type: object
      required:
        - vendor
        - model
        - input_tokens
        - output_tokens
        - total_tokens
      title: LLMMetadata
  securitySchemes:
    oidc:
      type: openIdConnect
      openIdConnectUrl: /.well-known/openid-configuration
    pat:
      type: http
      description: >-
        **Authentication:** You can generate a **Personal Access Token** from
        your [settings](https://getruba.com/settings).
      scheme: bearer
    oat:
      type: http
      description: >-
        **Authentication:** You can generate an **Organization Access Token**
        from your organization's settings.
      scheme: bearer

````